import React, { useEffect } from 'react';

function styleInject(css, ref) {
  if (ref === void 0) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') {
    return;
  }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z$1 = ":root {\n  --background: #fff;\n  --font-color: #494949;\n}\n\n@media (prefers-color-scheme: dark) {\n  :root {\n    --background: #3c3c3c;\n    --font-color: #fafafa;\n  }\n}\n.test-component {\n  background-color: var(--background);\n  color: var(--font-color);\n  border: 1px solid #131111;\n  padding: 16px;\n  width: 360px;\n  text-align: center;\n}\n.test-component .heading {\n  font-family: \"Avenir Next\", Helvetica, Arial, sans-serif;\n  font-size: 40px;\n  font-weight: bold;\n}";
styleInject(css_248z$1);

var TestComponent = function (_a) {
    var heading = _a.heading, content = _a.content;
    return (React.createElement("div", { "data-testid": "test-component", className: "test-component" },
        React.createElement("h1", { "data-testid": "test-component__heading", className: "heading" }, heading),
        React.createElement("div", { "data-testid": "test-component__content" }, content)));
};

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __generator(thisArg, body) {
  var _ = {
    label: 0,
    sent: function () {
      if (t[0] & 1) throw t[1];
      return t[1];
    },
    trys: [],
    ops: []
  },
      f,
      y,
      t,
      g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;

  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }

  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");

    while (_) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];

      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;

        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };

        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;

        case 7:
          op = _.ops.pop();

          _.trys.pop();

          continue;

        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }

          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }

          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }

          if (t && _.label < t[2]) {
            _.label = t[2];

            _.ops.push(op);

            break;
          }

          if (t[2]) _.ops.pop();

          _.trys.pop();

          continue;
      }

      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }

    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

  if (!it) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = it.call(o);
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

// ### Async & I/O
// Return Promise for getting an image.
// - use: imagePromise('./path/to/img').then(img => imageFcn(img))

/**
 * Return a Promise for getting an image.
 *
 * use: imagePromise('./path/to/img').then(img => imageFcn(img))
 * or: await imagePromise('./path/to/img')
 *
 * @param {URL} url string for path to image
 * @return {Promise} A promise resolving to the image
 */
function imagePromise(url) {
  return new Promise(function (resolve, reject) {
    var img = new Image();
    img.crossOrigin = "Anonymous";

    img.onload = function () {
      return resolve(img);
    }; // img.onerror = () => reject(Error(`Could not load image ${url}`))


    img.onerror = function () {
      return reject("Could not load image ".concat(url));
    };

    img.src = url;
  });
} // // Convert File blob (actually any blob) to Image
// https://developer.mozilla.org/en-US/docs/Web/API/Response#methods
// type = "arrayBuffer" "blob" "formData" "json" "text"
// export async function fetchType(url, type = 'text') {
//     const response = await fetch(url)
//     if (!response.ok) throw Error(`Not found: ${url}`)
//     const value = await response[type]()
//     return value
// }
// // Similar pair for requestAnimationFrame
// export function rafPromise() {
//     return new Promise(resolve => requestAnimationFrame(resolve))
// }
// export async function rafLoop(fcn, steps = -1) {
//     let i = 0
//     while (i++ !== steps) {
//         fcn(i - 1)
//         await rafPromise()
//     }
// }
//
// ### Canvas
// import { inWorker } from './dom.js'

function offscreenOK() {
  // return !!self.OffscreenCanvas
  // return typeof OffscreenCanvas !== 'undefined'
  return inWorker();
}
/**
 * Create a blank 2D canvas of a given width/height.
 *
 * @param {number} width The canvas height in pixels
 * @param {number} height The canvas width in pixels
 * @param {boolean} [offscreen=offscreenOK()] If true, return "Offscreen" canvas
 * @return {Canvas} The resulting Canvas object
 */


function createCanvas(width, height) {
  var offscreen = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : offscreenOK();
  if (offscreen) return new OffscreenCanvas(width, height);
  var can = document.createElement("canvas");
  can.width = width;
  can.height = height;
  return can;
}
/**
 * As above, but returing the 2D context object instead of the canvas.
 * Note ctx.canvas is the canvas for the ctx, and can be use as an image.
 *
 * @param {number} width The canvas height in pixels
 * @param {number} height The canvas width in pixels
 * @param {boolean} [offscreen=offscreenOK()] If true, return "Offscreen" canvas
 * @return {Context2D} The resulting Canvas's 2D context
 */

function createCtx(width, height) {
  var offscreen = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : offscreenOK();
  var can = createCanvas(width, height, offscreen);
  return can.getContext("2d");
} // Duplicate a canvas, preserving it's current image/drawing
// It does not install a transform and assumes there is not one currently installed.
// The World object can do that for AgentSets.

function setCanvasSize(can, width, height) {
  if (can.width !== width || can.height != height) {
    can.width = width;
    can.height = height;
  }
} // Install identity transform for this context.
// Call ctx.restore() to revert to previous transform.

function setIdentity(ctx) {
  ctx.save(); // NOTE: Does not change state, only saves current state.

  ctx.setTransform(1, 0, 0, 1, 0, 0); // or ctx.resetTransform()
} // Set the text font, align and baseline drawing parameters.
// Ctx can be either a canvas context or a DOM element
// See [reference](http://goo.gl/AvEAq) for details.
// * font is a HTML/CSS string like: "9px sans-serif"
// * align is left right center start end
// * baseline is top hanging middle alphabetic ideographic bottom

function setTextProperties(ctx, font) {
  var textAlign = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "center";
  var textBaseline = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "middle";
  Object.assign(ctx, {
    font: font,
    textAlign: textAlign,
    textBaseline: textBaseline
  });
} // Draw string of the given color at the xy location, in ctx pixel coords.
// Use setIdentity .. reset if a transform is being used by caller.

function drawText(ctx, string, x, y, color) {
  var useIdentity = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : true;
  if (useIdentity) setIdentity(ctx);
  ctx.fillStyle = color.css || color; // OK to use Color.typedColor

  ctx.fillText(string, x, y);
  if (useIdentity) ctx.restore();
} // # Draw string of the given color at the xy location, in ctx pixel coords.
// # Use setIdentity .. reset if a transform is being used by caller.
// ctxDrawText: (ctx, string, x, y, color, setIdentity = true) ->
//   @setIdentity(ctx) if setIdentity
//   ctx.fillStyle = color.css # @colorStr color
//   ctx.fillText(string, x, y)
//   ctx.restore() if setIdentity
// Return the (complete) ImageData object for this context object

function ctxImageData(ctx) {
  return ctx.getImageData(0, 0, ctx.canvas.width, ctx.canvas.height);
} // Clear this context using the cssColor.
// If no color or if color === 'transparent', clear to transparent.

function clearCtx(ctx) {
  var cssColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
  var _ctx$canvas = ctx.canvas,
      width = _ctx$canvas.width,
      height = _ctx$canvas.height;
  setIdentity(ctx);

  if (!cssColor || cssColor === "transparent") {
    ctx.clearRect(0, 0, width, height);
  } else {
    cssColor = cssColor.css || cssColor;
    ctx.fillStyle = cssColor;
    ctx.fillRect(0, 0, width, height);
  }

  ctx.restore();
} // These image functions use "imagable" objects: Image, ImageBitmap, Canvas ...

function fillCtxWithImage(ctx, img) {
  setIdentity(ctx); // set/restore identity

  ctx.drawImage(img, 0, 0, ctx.canvas.width, ctx.canvas.height);
  ctx.restore();
}
function inWorker() {
  return !inNode() && typeof self.window === "undefined";
}
function inNode() {
  return typeof global !== "undefined";
}

/**
 * Returns an int in [0, max), equal or grater than 0, less than max
 *
 * @param {number} max The max integer to return
 * @return {number} an integer in  [0, max)
 */

var randomInt = function randomInt(max) {
  return Math.floor(Math.random() * max);
};
/**
 * Returns an int in [min, max), equal or grater than min, less than max
 *
 * @param {number} min The min integer to return
 * @param {number} max The max integer to return
 * @return {number} an integer in  [min, max)
 */

var randomInt2 = function randomInt2(min, max) {
  return min + Math.floor(Math.random() * (max - min));
};
/**
 * Returns a random float in [min, max)
 *
 * @param {number} min The min float to return
 * @param {number} max The max float to return
 * @return {number} a float in [min, max)
 */

var randomFloat2 = function randomFloat2(min, max) {
  return min + Math.random() * (max - min);
};
// The modulus is defined as: x - y * floor(x / y)
// It is not %, the remainder function.

/**
 * A true modulus function, differing from the % remainder operation.
 *
 * @param {number} v The value to calculate the modulus of
 * @param {number} n The number relative to which the modulus is calculated.
 * @returns {number} The value of v mod n
 */

var mod = function mod(v, n) {
  return (v % n + n) % n;
}; // v - n * Math.floor(v / n)
/**
 * Clamp a float to be between [min, max).
 *
 * @param {number} v value to clamp between min & max
 * @param {number} min min value
 * @param {number} max max value
 * @return {number} a float between min/max
 */

function clamp(v, min, max) {
  if (v < min) return min;
  if (v > max) return max;
  return v;
} // Return true is val in [min, max] enclusive
// Scale is in [0-1], a percentage, and the result is in [lo,hi]
// If lo>hi, scaling is from hi end of range.
// [Why the name `lerp`?](http://goo.gl/QrzMc)

var lerp = function lerp(lo, hi, scale) {
  return lo <= hi ? lo + (hi - lo) * scale : lo - (lo - hi) * scale;
}; // Calculate the lerp scale given lo/hi pair and a number between them.
// Clamps number to be between lo & hi.

function lerpScale(number, lo, hi) {
  if (lo === hi) throw Error("lerpScale: lo === hi");
  number = clamp(number, lo, hi);
  return (number - lo) / (hi - lo);
} // ### Geometry

var arraysToString = function arraysToString(arrays) {
  return arrays.map(function (a) {
    return "".concat(a);
  }).join(",");
}; // Execute fcn for all own member of an obj or array (typed OK).
// Return input arrayOrObj, transformed by fcn.
// - Unlike forEach, does not skip undefines.
// - Like map, forEach, etc, fcn = fcn(item, key/index, obj).
// - Alternatives are: `for..of`, array map, reduce, filter etc

function forLoop(arrayOrObj, fcn) {
  if (arrayOrObj.slice) {
    // typed & std arrays
    for (var i = 0, len = arrayOrObj.length; i < len; i++) {
      fcn(arrayOrObj[i], i, arrayOrObj);
    }
  } else {
    // obj
    Object.keys(arrayOrObj).forEach(function (k) {
      return fcn(arrayOrObj[k], k, arrayOrObj);
    });
  } // return arrayOrObj

} // Repeat function f(i, a) n times, i in 0, n-1
// a is optional array, default a new Array.
// Return a.

/**
 * Repeats the function f(i, a) i in 0, n-1.
 * a is an optional array, default a new empty Array
 * returns a, only needed if f() places data in a
 *
 * @param {number} n An integer number of times to run f()
 * @param {function} f The function called.
 * @param {Array} [a=[]] An optional array for use by f()
 * @return {Array} The result of calling f() n times
 */

function repeat(n, f) {
  var a = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  for (var i = 0; i < n; i++) {
    f(i, a);
  }

  return a;
} // Repeat function n times, incrementing i by step each call.

function step(n, step, f) {
  for (var i = 0; i < n; i += step) {
    f(i);
  }
} // Return range [0, length-1]. Note: 6x faster than Array.from!
/**
 * Return random item from an array
 *
 * @param {Array} An array to choose from
 * @returns {any} The chosen item
 */
// Return random one of array items.

var oneOf = function oneOf(array) {
  return array[randomInt(array.length)];
};

var oneKeyOf = function oneKeyOf(obj) {
  return oneOf(Object.keys(obj));
};
var oneValOf = function oneValOf(obj) {
  return obj[oneKeyOf(obj)];
}; // export function oneKeyOf(obj) {
// in [start,stop] with numItems (positive integer > 1).
// OK for start>stop. Will always include start/stop w/in float accuracy.

function floatRamp(start, stop, numItems) {
  // NOTE: start + step*i, where step is (stop-start)/(numItems-1),
  // has float accuracy problems, must recalc step each iteration.
  if (numItems <= 1) throw Error("floatRamp: numItems must be > 1");
  var a = [];

  for (var i = 0; i < numItems; i++) {
    a.push(start + (stop - start) * (i / (numItems - 1)));
  }

  return a;
} // Integer version of floatRamp, start & stop integers, rounding each element.
// Default numItems yields unit step between start & stop.

function integerRamp(start, stop) {
  var numItems = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Math.abs(stop - start) + 1;
  return floatRamp(start, stop, numItems).map(function (a) {
    return Math.round(a);
  });
} // Return an array normalized (lerp) between lo/hi values
// export function clone(array) {
//     return array.slice(0)
// }
// // Simple uniq on sorted or unsorted array.
// export const uniq = array => Array.from(new Set(array))
// import { isObject, isTypedArray } from './types.js'
// import { forLoop } from './objects.js'
// ### OofA/AofO

function isOofA(data) {
  if (!isObject(data)) return false;
  return Object.values(data).every(function (v) {
    return isTypedArray(v);
  });
}
function oofaObject(oofa, i, keys) {
  var obj = {};
  keys.forEach(function (key) {
    obj[key] = oofa[key][i];
  });
  return obj;
}
function toAofO(oofa) {
  var keys = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Object.keys(oofa);
  var length = oofa[keys[0]].length;
  var aofo = new Array(length);
  forLoop(aofo, function (val, i) {
    aofo[i] = oofaObject(oofa, i, keys);
  });
  return aofo;
}
// Fix the javascript typeof operator https://goo.gl/Efdzk5

var typeOf = function typeOf(obj) {
  return {}.toString.call(obj).match(/\s(\w+)/)[1].toLowerCase();
};
var isType = function isType(obj, string) {
  return typeOf(obj) === string;
};
var isOneOfTypes = function isOneOfTypes(obj, array) {
  return array.includes(typeOf(obj));
};
var isString = function isString(obj) {
  return isType(obj, "string");
};
var isObject = function isObject(obj) {
  return isType(obj, "object");
}; // export const isArray = obj => isType(obj, 'array')

var isCanvas = function isCanvas(obj) {
  return isOneOfTypes(obj, ["htmlcanvaselement", "offscreencanvas"]);
};
var isImageable = function isImageable(obj) {
  return isOneOfTypes(obj, ["image", "htmlimageelement", "htmlcanvaselement", "offscreencanvas", "imagebitmap"]);
}; // Typed Arrays:

var isTypedArray = function isTypedArray(obj) {
  return typeOf(obj.buffer) === "arraybuffer";
};
// export const isWebglArray = obj =>
//     Array.isArray(obj) && obj.length === 3 && util.arrayMax(obj) <= 1
// isHtmlElement: obj => /^html.*element$/.test(typeOf(obj))
// isImage: obj => isType(obj, 'image')
// isImageBitmap: obj => isType(obj, 'imagebitmap')
// // Is undefined, null, bool, number, string, symbol
// isPrimitive: obj => obj == null || 'object' != typeof obj
// Return array's type (Array or TypedArray variant)
// typeName: obj => obj.constructor.name

// It will be  upgraded with methods converting from other
// transforms like  GIS and DataSets.
// const defaultZ = (maxX, maxY) => Math.max(maxX, maxY)

/**
 * @private
 * @typedef {Object} WorldOptions
 * @property {number} minX Max world patch x integer value
 * @property {number} minY Max world patch y integer value
 * @property {number} minZ Max world patch z integer value
 * @property {number} maxX Min world patch x integer value
 * @property {number} maxY Min world patch y integer value
 * @property {number} maxZ Min world patch z integer value
 */

/**
 * @description
 * Class World defines the coordinate system for the model.
 * It has transforms for multiple coordinate systems.
 *
 * The world is defined by an object with 6 properties:
 *
 *          WorldOptions = {
 *              minX: integer,
 *              maxX: integer,
 *              minY: integer,
 *              maxY: integer,
 *              minZ: integer,
 *              maxZ: integer,
 *          }
 */

var World = /*#__PURE__*/function () {
  /**
   * Create a new World object given an Object with optional
   * minX, maxX, minY, maxY, minZ, maxZ overriding class properties.
   * @param {World|WorldOptions|Object} options Object with overrides for class properties
   */
  function World() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, World);

    _defineProperty(this, "maxX", 16);

    _defineProperty(this, "maxY", 16);

    _defineProperty(this, "maxZ", 16);

    _defineProperty(this, "minX", -16);

    _defineProperty(this, "minY", -16);

    _defineProperty(this, "minZ", -16);

    Object.assign(this, options); // set the option override values

    this.setWorld(); // convert these to rest of world parameters
  }
  /**
   * Return a default options object, origin at center.
   *
   * @param {number} [maxX=16] Integer max X value
   * @param {number} [maxY=maxX] Integer max Y value
   * @param {number} [maxZ=Math.max(maxX, maxY)] Integer max Z value
   * @returns {WorldOptions}
   */


  _createClass(World, [{
    key: "setWorld",
    value: // ======================
    function setWorld() {
      // Complete properties derived from minX/Y, maxX/Y (patchSize === 1)
      var minX = this.minX,
          maxX = this.maxX,
          minY = this.minY,
          maxY = this.maxY,
          minZ = this.minZ,
          maxZ = this.maxZ;
      forLoop({
        minX: minX,
        maxX: maxX,
        minY: minY,
        maxY: maxY,
        minZ: minZ,
        maxZ: maxZ
      }, function (val, key) {
        if (!Number.isInteger(val)) throw Error("".concat(key, ":").concat(val, " must be an integer"));
      });
      this.numX = this.width = maxX - minX + 1;
      this.numY = this.height = maxY - minY + 1; // if (maxZ == null) maxZ = this.maxZ = Math.max(this.width, this.height)

      this.numZ = this.depth = maxZ - minZ + 1;
      this.minXcor = minX - 0.5;
      this.maxXcor = maxX + 0.5;
      this.minYcor = minY - 0.5;
      this.maxYcor = maxY + 0.5;
      this.minZcor = minZ - 0.5;
      this.maxZcor = maxZ + 0.5; // The midpoints of the world, in world coords.

      this.centerX = (minX + maxX) / 2;
      this.centerY = (minY + maxY) / 2;
      this.centerZ = (minZ + maxZ) / 2;
      this.numPatches = this.numX * this.numY;
    }
    /**
     * Return the options (minX, maxX, ..) used to create this world.
     *
     * @returns {Object} A WorldOptions object
     */

  }, {
    key: "getOptions",
    value: function getOptions() {
      var minX = this.minX,
          minY = this.minY,
          minZ = this.minZ,
          maxX = this.maxX,
          maxY = this.maxY,
          maxZ = this.maxZ;
      return {
        minX: minX,
        minY: minY,
        minZ: minZ,
        maxX: maxX,
        maxY: maxY,
        maxZ: maxZ
      };
    }
    /**
     * Return a random 2D point within the World
     *
     * @returns {Array} A random x,y float array
     */

  }, {
    key: "randomPoint",
    value: function randomPoint() {
      return [randomFloat2(this.minXcor, this.maxXcor), randomFloat2(this.minYcor, this.maxYcor)];
    }
    /**
     * Return a random 3D point within the World
     *
     * @returns {Array} A random x,y,z float array
     */

  }, {
    key: "random3DPoint",
    value: function random3DPoint() {
      return [randomFloat2(this.minXcor, this.maxXcor), randomFloat2(this.minYcor, this.maxYcor), randomFloat2(this.minZcor, this.maxZcor)];
    }
    /**
     * Return a random Patch 2D integer point
     *
     * @returns {Array}  A random x,y integer array
     */

  }, {
    key: "randomPatchPoint",
    value: function randomPatchPoint() {
      return [randomInt2(this.minX, this.maxX), randomInt2(this.minY, this.maxY)];
    }
    /**
     * Given x,y,z values return true if within the world
     *
     * @param {number} x x value
     * @param {number} y y value
     * @param {number} [z=this.centerZ] z value
     * @returns {boolean} Whether or not on-world
     */

  }, {
    key: "isOnWorld",
    value: function isOnWorld(x, y) {
      var z = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.centerZ;
      return this.minXcor <= x && x <= this.maxXcor && //
      this.minYcor <= y && y <= this.maxYcor && //
      this.minZcor <= z && z <= this.maxZcor;
    } // cropToWorld(x, y) {}
    // Note minX etc NOT the world's but of the coord sys we want to use.

    /**
     * Return an instance of a bounding box 2D transform.
     * It linearly interpolates between the given minX, minY, maxX, maxY,
     * and the world's values of the same properties.
     *
     * The parameters are in the popular geojson order: west, south, east, north
     *
     * Useful for Canvas top-left transforms and geojson transforms.
     *
     * @param {number} minX min bounding box x value
     * @param {number} minY min bounding box y value
     * @param {number} maxX max bounding box x value
     * @param {number} maxY max bounding box y value
     * @returns {BBoxTransform} Instance of the BBoxTransform
     */

  }, {
    key: "bboxTransform",
    value: function bboxTransform(minX, minY, maxX, maxY) {
      return new BBoxTransform(minX, minY, maxX, maxY, this);
    } // ### Following use PatchSize
    // Get the world size in pixels. PatchSize is optional, defalting to 1

  }, {
    key: "getWorldSize",
    value: function getWorldSize() {
      var patchSize = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return [this.numX * patchSize, this.numY * patchSize];
    } // Convert a canvas context to world euclidean coordinates
    // Change the ctx.canvas size, determined by patchSize.

  }, {
    key: "setEuclideanTransform",
    value: function setEuclideanTransform(ctx, patchSize) {
      // ctx.canvas.width = this.numX * patchSize
      // ctx.canvas.height = this.numY * patchSize
      this.setCanvasSize(ctx.canvas, patchSize);
      ctx.restore(); // close earlier save(). OK if no save called yet.

      ctx.save();
      ctx.scale(patchSize, -patchSize);
      ctx.translate(-this.minXcor, -this.maxYcor);
    } // Return patch size for given canvas.
    // Error if canvas patch width/height differ.

  }, {
    key: "patchSize",
    value: function patchSize(canvas) {
      var numX = this.numX,
          numY = this.numY;
      var width = canvas.clientWidth,
          height = canvas.clientHeight;
      var xSize = width / numX;
      var ySize = height / numY;

      if (xSize !== ySize) {
        throw Error("World patchSize: x/y sizes differ ".concat(xSize, ", ").concat(ySize));
      }

      return xSize;
    } // Change canvas size to this world's size.
    // Does not change size if already the same, preserving the ctx content.

  }, {
    key: "setCanvasSize",
    value: function setCanvasSize$1(canvas, patchSize) {
      var _this$getWorldSize = this.getWorldSize(patchSize),
          _this$getWorldSize2 = _slicedToArray(_this$getWorldSize, 2),
          width = _this$getWorldSize2[0],
          height = _this$getWorldSize2[1];

      setCanvasSize(canvas, width, height);
    } // Convert pixel location (top/left offset i.e. mouse) to patch coords (float)

  }, {
    key: "pixelXYtoPatchXY",
    value: function pixelXYtoPatchXY(x, y, patchSize) {
      return [this.minXcor + x / patchSize, this.maxYcor - y / patchSize];
    } // Convert patch coords (float) to pixel location (top/left offset i.e. mouse)

  }, {
    key: "patchXYtoPixelXY",
    value: function patchXYtoPixelXY(x, y, patchSize) {
      return [(x - this.minXcor) * patchSize, (this.maxYcor - y) * patchSize];
    }
  }, {
    key: "xyToPatchIndex",
    value: function xyToPatchIndex(x, y) {
      if (!this.isOnWorld(x, y)) return undefined;
      var minX = this.minX,
          maxX = this.maxX,
          maxY = this.maxY,
          numX = this.numX,
          maxXcor = this.maxXcor,
          maxYcor = this.maxYcor;
      x = x === maxXcor ? maxX : Math.round(x);
      y = y === maxYcor ? maxY : Math.round(y);
      return x - minX + numX * (maxY - y);
    } // patchIndexToXY(index) {}

  }], [{
    key: "defaultOptions",
    value: function defaultOptions() {
      var maxX = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 16;
      var maxY = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : maxX;
      var maxZ = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Math.max(maxX, maxY);
      return {
        minX: -maxX,
        maxX: maxX,
        minY: -maxY,
        maxY: maxY,
        minZ: -maxZ,
        maxZ: maxZ
      };
    }
    /**
     * Factory to create a default World instance.
     *
     * @param {number} [maxX=16] Integer max X value
     * @param {number} [maxY=maxX] Integer max Y value
     * @param {number} [maxZ=Math.max(maxX, maxY)] Integer max Z value
     * @returns {World}
     */

  }, {
    key: "defaultWorld",
    value: function defaultWorld() {
      var maxX = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 16;
      var maxY = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : maxX;
      var maxZ = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : maxX;
      return new World(World.defaultOptions(maxX, maxY, maxZ));
    }
  }]);

  return World;
}();

var BBoxTransform = /*#__PURE__*/function () {
  /**
   * Creates an instance of BBoxTransform.
   * See https://tools.ietf.org/html/rfc7946#section-5
   * .. which defines bbox as [west, south, east, north]
   * .. which is the bbox [minX, minY, maxX, maxY]
   * @param {number} minX min bounding box x value
   * @param {number} minY max bounding box x value
   * @param {number} maxX min bounding box y value
   * @param {number} maxY max bounding box y value
   * @param {World} world instance of a World object
   */
  function BBoxTransform(minX, minY, maxX, maxY, world) {
    _classCallCheck(this, BBoxTransform);

    this.bbox = [minX, minY, maxX, maxY];
    if (minX < maxX) console.log("flipX");
    if (maxY < minY) console.log("flipY");

    if (minX < maxX) {
      var _ref = [maxX, minX];
      minX = _ref[0];
      maxX = _ref[1];
    }

    if (maxY < minY) {
      var _ref2 = [minY, maxY];
      maxY = _ref2[0];
      minY = _ref2[1];
    }

    var maxXcor = world.maxXcor,
        maxYcor = world.maxYcor,
        minXcor = world.minXcor,
        minYcor = world.minYcor;
    var mx = (minX - maxX) / (maxXcor - minXcor);
    var my = (maxY - minY) / (maxYcor - minYcor);
    var bx = (minX + maxX - mx * (maxXcor + minXcor)) / 2;
    var by = (maxY + minY - my * (maxYcor + minYcor)) / 2;
    Object.assign(this, {
      mx: mx,
      my: my,
      bx: bx,
      by: by
    });
  }
  /**
   * Convert from bbox point to world point
   *
   * @param {Array} bboxPoint A point in the bbox coordinates
   * @returns {Array} A point in the world coordinates
   */


  _createClass(BBoxTransform, [{
    key: "toWorld",
    value: function toWorld(bboxPoint) {
      var mx = this.mx,
          my = this.my,
          bx = this.bx,
          by = this.by;

      var _bboxPoint = _slicedToArray(bboxPoint, 2),
          bboxX = _bboxPoint[0],
          bboxY = _bboxPoint[1];

      var x = (bboxX - bx) / mx;
      var y = (bboxY - by) / my;
      return [x, y];
    }
    /**
     * Convert from world point to bbox point
     *
     * @param {Array} worldPoint A point in the world coordinates
     * @returns {Array} A point in the bbox coordinates
     */

  }, {
    key: "toBBox",
    value: function toBBox(worldPoint) {
      var mx = this.mx,
          my = this.my,
          bx = this.bx,
          by = this.by;

      var _worldPoint = _slicedToArray(worldPoint, 2),
          worldX = _worldPoint[0],
          worldY = _worldPoint[1];

      var x = mx * worldX + bx;
      var y = my * worldY + by;
      return [x, y];
    } // aspectRatio() {
    //     const [west, south, east, north] = this.bbox
    //     return Math.abs((east - west) / (north - south))
    // }
    // Return center [x,y] of bbox in bbox coords.

  }, {
    key: "bboxCenter",
    value: function bboxCenter() {
      var _this$bbox = _slicedToArray(this.bbox, 4),
          west = _this$bbox[0],
          south = _this$bbox[1],
          east = _this$bbox[2],
          north = _this$bbox[3];

      return [(west + east) / 2, (south + north) / 2];
    } // Return 4 coordinate points of bbox corners, from topLeft, clockwise.

  }, {
    key: "bboxCoords",
    value: function bboxCoords() {
      var _this$bbox2 = _slicedToArray(this.bbox, 4),
          west = _this$bbox2[0],
          south = _this$bbox2[1],
          east = _this$bbox2[2],
          north = _this$bbox2[3];

      return [[west, north], [east, north], [east, south], [west, south]];
    }
  }]);

  return BBoxTransform;
}();

/**
 * A general color module, supporting css string colors, canvas2d pixel
 * colors, webgl and canvas2d Uint8ClampedArray r,g,b,a arrays.
 *
 * ### CSS Color Strings.
 *
 * CSS colors in HTML are strings, see [Mozillas Color Reference](
 * https://developer.mozilla.org/en-US/docs/Web/CSS/color_value),
 * taking one of 7 forms:
 *
 * * Names: over 140 color case-insensitive names like
 *   Red, Green, CadetBlue, etc.
 * * Hex, short and long form: #0f0, #ff10a0
 * * RGB: rgb(255, 0, 0), rgba(255, 0, 0, 0.5)
 * * HSL: hsl(120, 100%, 50%), hsla(120, 100%, 50%, 0.8)
 *
 * See [this wikipedia article](https://goo.gl/ev8Kw0)
 * on differences between HSL and HSB/HSV.
 */

var Color = {
  /**
   * Convert 4 r,g,b,a ints in [0-255] ("a" defaulted to 255) to a
   * css color string.
   */
  // Alpha "a" is converted to float in 0-1 for css string.
  // We use alpha in [0-255] to be compatible with TypedArray conventions.
  rgbaCssColor: function rgbaCssColor(r, g, b) {
    var a = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 255;
    a = a / 255;
    var a2 = a.toPrecision(2);
    return a === 1 ? "rgb(".concat(r, ",").concat(g, ",").concat(b, ")") : "rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(a2, ")");
  },

  /**
   * Convert 4 ints, h,s,l,a, h in [0-360], s,l in [0-100]% a in [0-255] to a
   * css color string.
   *
   * NOTE: h=0 and h=360 are the same, use h in 0-359 for unique colors.
   */
  // Alpha "a" is converted to float in 0-1 for css string.
  hslCssColor: function hslCssColor(h, s, l) {
    var a = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 255;
    a = a / 255;
    var a4 = a.toPrecision(4);
    return a === 1 ? "hsl(".concat(h, ",").concat(s, "%,").concat(l, "%)") : "hsla(".concat(h, ",").concat(s, "%,").concat(l, "%,").concat(a4, ")");
  },
  // Return a html/css hex color string for an r,g,b opaque color (a=255).
  // Hex strings do not support alpha.
  //
  // Both #nnn and #nnnnnn forms supported.
  // Default is to check for the short hex form.
  hexCssColor: function hexCssColor(r, g, b) {
    return "#".concat((0x1000000 | (b | g << 8 | r << 16)).toString(16).slice(-6));
  },
  // cssColor is a hybrid string and is our standard.  It returns:
  //
  // * rgbaCssColor if a not 255 (i.e. not opaque)
  // * hexCssColor otherwise
  cssColor: function cssColor(r, g, b) {
    var a = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 255;
    return a === 255 ? this.hexCssColor(r, g, b, true) : this.rgbaCssColor(r, g, b, a);
  },
  randomCssColor: function randomCssColor() {
    var r255 = function r255() {
      return randomInt(256);
    }; // random int in [0,255]


    return this.cssColor(r255(), r255(), r255());
  },
  randomGrayCssColor: function randomGrayCssColor() {
    var min = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var max = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 255;
    var gray = randomInt2(min, max); // random int in [min,max]

    return this.cssColor(gray, gray, gray);
  },
  // ### Pixels
  cssToPixel: function cssToPixel(string) {
    var rgba = this.cssToUint8Array(string);
    return this.rgbaToPixel.apply(this, _toConsumableArray(rgba));
  },
  rgbaToPixel: function rgbaToPixel(r, g, b) {
    var a = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 255;
    var rgba = new Uint8Array([r, g, b, a]);
    var pixels = new Uint32Array(rgba.buffer);
    return pixels[0];
  },
  randomPixel: function randomPixel() {
    var r255 = function r255() {
      return randomInt(256);
    }; // random int in [0,255]


    return this.rgbaToPixel(r255(), r255(), r255());
  },
  randomGrayPixel: function randomGrayPixel() {
    var min = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var max = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 255;
    var gray = randomInt2(min, max); // random int in [min,max]

    return this.rgbaToPixel(gray, gray, gray);
  },
  // ### CSS String Conversions
  // Return 4 element array given any legal CSS string color.
  //
  // Because strings vary widely: CadetBlue, #0f0, rgb(255,0,0),
  // hsl(120,100%,50%), we do not parse strings, instead we let
  // the browser do our work: we fill a 1x1 canvas with the css string color,
  // returning the r,g,b,a canvas ImageData TypedArray.
  // The shared 1x1 canvas 2D context.
  sharedCtx1x1: createCtx(1, 1),
  // share across calls.
  // Convert any css string to 4 element Uint8ClampedArray TypedArray.
  // If you need a JavaScript Array, use `new Array(...TypedArray)`
  // Slow, but works for all css strings: hsl, rgb, .. as well as names.
  cssToUint8Array: function cssToUint8Array(string) {
    this.sharedCtx1x1.clearRect(0, 0, 1, 1);
    this.sharedCtx1x1.fillStyle = string;
    this.sharedCtx1x1.fillRect(0, 0, 1, 1);
    return this.sharedCtx1x1.getImageData(0, 0, 1, 1).data;
  },
  // ### Typed Color
  // A TypedColor is a 4 element ArrayBuffer, with two views:
  //
  // * pixelArray: A single element Uint32Array view
  // * u8array: A 4 element r,g,b,a Uint8ClampedArray view
  //
  // getters/setters are provided for multiple other color types:
  //  'css', 'pixel', 'rgb', 'webgl'
  // If g is undefinec, returns toTypedColor(g)
  typedColor: function typedColor(r, g, b) {
    var a = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 255;
    if (g === undefined) return this.toTypedColor(r);
    var u8array = new Uint8ClampedArray([r, g, b, a]);
    u8array.pixelArray = new Uint32Array(u8array.buffer); // one element array
    // Make this an instance of TypedColorProto

    Object.setPrototypeOf(u8array, TypedColorProto);
    return u8array;
  },
  isTypedColor: function isTypedColor(any) {
    return any && any.constructor === Uint8ClampedArray && any.pixelArray;
  },
  // Return a typedColor given a value and optional colorType
  // If the value already is a typedColor, simply return it
  // If colorType not defined, assume css (string) or pixel (number)
  // The colorType can be: 'css', 'pixel', 'rgb', 'webgl'
  // Note rgb and webgl are int arrays & float arrays respectively.
  toTypedColor: function toTypedColor(value, colorType) {
    if (this.isTypedColor(value)) return value;
    var tc = this.typedColor(0, 0, 0, 0); // "empty" typed color

    if (colorType == null) {
      if (typeof value === "string") tc.css = value;else if (typeof value === "number") tc.pixel = value;else throw Error("toTypedColor: illegal value ".concat(value));
    } else {
      // REMIND: type check value & colorType?
      tc[colorType] = value;
    }

    return tc;
  },
  // Random typedColor, rgb or gray, alpha = 255 for both:
  randomTypedColor: function randomTypedColor() {
    var r255 = function r255() {
      return randomInt(256);
    }; // random int in [0,255]


    return this.typedColor(r255(), r255(), r255());
  },
  // Random gray color, alpha = 255
  randomGrayTypedColor: function randomGrayTypedColor() {
    var min = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var max = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 255;
    var gray = randomInt2(min, max); // random int in [min,max]

    return this.typedColor(gray, gray, gray);
  },
  // Arrays of random typed colors, very useful for patch colors
  randomColorArray: function randomColorArray(length) {
    var _this = this;

    var colors = new Array(length);
    forLoop(colors, function (c, i) {
      return colors[i] = _this.randomTypedColor();
    });
    return colors;
  },
  randomGrayArray: function randomGrayArray(length) {
    var _this2 = this;

    var min = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    var max = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 255;
    var grays = new Array(length);
    forLoop(grays, function (g, i) {
      return grays[i] = _this2.randomGrayTypedColor(min, max);
    });
    return grays;
  }
}; // Prototype for Color. Getters/setters for usability, may be slower.

var TypedColorProto = {
  // Inherit from Uint8ClampedArray
  __proto__: Uint8ClampedArray.prototype,
  // Set the Color to new rgba values.
  setColor: function setColor(r, g, b) {
    var a = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 255;
    this.checkColorChange();
    this[0] = r;
    this[1] = g;
    this[2] = b;
    this[3] = a;
  },

  // No real need for getColor, it *is* the typed Uint8 array
  set rgb(rgbaArray) {
    this.setColor.apply(this, _toConsumableArray(rgbaArray));
  },

  get rgb() {
    return this;
  },

  // Set opacity to a value in 0-255
  setAlpha: function setAlpha(alpha) {
    this.checkColorChange();
    this[3] = alpha; // Uint8ClampedArray will clamp to 0-255
  },
  getAlpha: function getAlpha() {
    return this[3];
  },

  get alpha() {
    return this.getAlpha();
  },

  set alpha(alpha) {
    this.setAlpha(alpha);
  },

  // Set the Color to a new pixel value
  setPixel: function setPixel(pixel) {
    this.checkColorChange();
    this.pixelArray[0] = pixel;
  },
  // Get the pixel value
  getPixel: function getPixel() {
    return this.pixelArray[0];
  },

  get pixel() {
    return this.getPixel();
  },

  set pixel(pixel) {
    this.setPixel(pixel);
  },

  // Set pixel/rgba values to equivalent of the css string.
  // 'red', '#f00', 'ff0000', 'rgb(255,0,0)', etc.
  //
  // Does *not* set the chached this.string, which will be lazily evaluated
  // to its common cssColor by getCss(). The above would all return '#f00'.
  setCss: function setCss(string) {
    return this.setColor.apply(this, _toConsumableArray(Color.cssToUint8Array(string)));
  },
  // Return the cssColor for this Color, cached in the @string value
  getCss: function getCss() {
    if (this.string == null) this.string = Color.cssColor.apply(Color, _toConsumableArray(this));
    return this.string;
  },

  get css() {
    return this.getCss();
  },

  set css(string) {
    this.setCss(string);
  },

  // Note: webgl colors are 3 RGB floats (no A)
  setWebgl: function setWebgl(array) {
    if (array.length !== 3) throw Error("setWebgl array length must be 3, length:", array.length);
    this.setColor( // OK if float * 255 non-int, setColor stores into uint8 array
    array[0] * 255, array[1] * 255, array[2] * 255);
  },
  getWebgl: function getWebgl() {
    return [this[0] / 255, this[1] / 255, this[2] / 255];
  },

  get webgl() {
    return this.getWebgl();
  },

  set webgl(array) {
    this.setWebgl(array);
  },

  // Housekeeping when the color is modified.
  checkColorChange: function checkColorChange() {
    // Reset string & webgl on color change.
    this.string = null; // will be lazy evaluated via getCss.

    this.floatArray = null;
  },
  // Return true if color is same value as myself, comparing pixels
  equals: function equals(color) {
    return this.getPixel() === color.getPixel();
  },
  toString: function toString() {
    return "[".concat(Array.from(this).toString(), "]");
  },
  // Return a [distance metric](
  // http://www.compuphase.com/cmetric.htm) between two colors.
  // Max distance is roughly 765 (3*255), for black & white.
  // For our purposes, omitting the sqrt will not effect our results
  rgbDistance: function rgbDistance(r, g, b) {
    var _this3 = _slicedToArray(this, 3),
        r1 = _this3[0],
        g1 = _this3[1],
        b1 = _this3[2];

    var rMean = Math.round((r1 + r) / 2);
    var dr = r1 - r,
        dg = g1 - g,
        db = b1 - b;
    var dr2 = dr * dr,
        dg2 = dg * dg,
        db2 = db * db;
    var distanceSq = ((512 + rMean) * dr2 >> 8) + 4 * dg2 + ((767 - rMean) * db2 >> 8);
    return distanceSq; // Math.sqrt(distanceSq)
  }
};

function getPixel(color) {
  if (typeof pixel === "number") return pixel;
  if (color.pixel) return color.pixel;
  return Color.toTypedColor(color).pixel;
}

var PatchesView = /*#__PURE__*/function () {
  // Ctor: create a 2D context and imageData for this View
  function PatchesView(width, height) {
    _classCallCheck(this, PatchesView);

    this.ctx = createCtx(width, height);
    this.resetImageData(); // this.imageData = util.ctxImageData(this.ctx)
    // this.pixels = new Uint32Array(this.imageData.data.buffer)
    // this.length = this.pixels.length

    this.useImageSmoothing = false;
  } // Set the imageData and pixels values from the pixel's canvas ctx


  _createClass(PatchesView, [{
    key: "resetImageData",
    value: function resetImageData() {
      this.imageData = ctxImageData(this.ctx);
      this.pixels = new Uint32Array(this.imageData.data.buffer); // this.length = this.pixels.length
    }
  }, {
    key: "setPatchesSmoothing",
    value: function setPatchesSmoothing(smoothting) {
      this.useImageSmoothing = smoothting;
    } // Install pixels in this imageData object.
    // pixelFcn(d) returns a pixel for each data item.data can be patches
    // or data derived from patches using patch state values.

  }, {
    key: "setPixels",
    value: function setPixels(data) {
      var _this = this;

      var pixelFcn = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function (d) {
        return d;
      };
      if (isOofA(data)) data = toAofO(data);

      if (data.length !== this.pixels.length) {
        throw Error("setPixels, data.length != pixels.length " + data.length + " " + this.pixels.length);
      }

      forLoop(data, function (d, i) {
        _this.pixels[i] = getPixel(pixelFcn(d));
      }); // if (updateCanvas) this.ctx.putImageData(this.imageData, 0, 0)
    }
  }, {
    key: "createPixels",
    value: function createPixels(pixelFcn) {
      var _this2 = this;

      repeat(this.pixels.length, function (i) {
        _this2.pixels[i] = getPixel(pixelFcn(i));
      }); // if (updateCanvas) this.ctx.putImageData(this.imageData, 0, 0)
    } // Used to be: setPixel(x, y, pixel) {
    // but best to be purely independent of world object

  }, {
    key: "setPixel",
    value: function setPixel(index, pixel) {
      // const index = world.xyToPatchIndex(x, y)
      this.pixels[index] = getPixel(pixel);
    } // Draw this pixel canvas onto a View 2D canvas ctx.

  }, {
    key: "draw",
    value: function draw(ctx) {
      var smoothing = this.ctx.imageSmoothingEnabled;
      ctx.imageSmoothingEnabled = this.useImageSmoothing;
      this.ctx.putImageData(this.imageData, 0, 0); // this.updateCanvas()

      fillCtxWithImage(ctx, this.ctx.canvas);
      ctx.imageSmoothingEnabled = smoothing;
    }
  }, {
    key: "clear",
    value: function clear(color) {
      // typedColor -> css
      color = color.css || color;

      if (!color || typeof color === "string") {
        clearCtx(this.ctx, color);
      } else if (typeof color === "number") {
        this.createPixels(function () {
          return color;
        });
      } else {
        throw Error("patchesView.clear(): illegal color " + color);
      }

      if (typeof color === "number") {
        this.updateCanvas();
      } else {
        this.resetImageData();
      }
    } // Return promise for an ImageBitmap of the current ctx
    // Note safari does not support createImageBitmap as of 4/20/19
    // REMIND: See if imagebitmaps can avoid img alpha premultiply etc

  }, {
    key: "getImageBitmap",
    value: function getImageBitmap() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return createImageBitmap(this.imageData, options);
    }
  }, {
    key: "drawImageBitmap",
    value: function drawImageBitmap(ctx) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      createImageBitmap(this.imageData, options).then(function (img) {
        return fillCtxWithImage(ctx, img);
      });
    } // Push imageData to canvas, return the canvas

  }, {
    key: "updateCanvas",
    value: function updateCanvas() {
      this.ctx.putImageData(this.imageData, 0, 0);
      return this.ctx.canvas;
    }
  }]);

  return PatchesView;
}();

function cssColor$1(color) {
  if (color) return color.css || color;
  return color;
} // Shapes are Canvas2D drawings in -0.5 to +0.5, unit squares
// They are drawn on a Canvas2D using transforms for x, y, theta


var Shapes = /*#__PURE__*/function () {
  function Shapes() {
    _classCallCheck(this, Shapes);

    this.cache = {};
    this.paths = paths; // For accessing the paths thru the Shapes instance
  } // Add a new path. Error if name already used


  _createClass(Shapes, [{
    key: "addPath",
    value: function addPath(name, pathFunction) {
      if (this.getPath(name)) ;
      paths[name] = pathFunction;
    } // NOTE: convention: if shapeName ends in 2, then needs strokeColor

  }, {
    key: "needsStrokeColor",
    value: function needsStrokeColor(shapeName) {
      return shapeName.endsWith("2");
    } // Get an array of path names. Can change over time via addPath()

  }, {
    key: "getPathNames",
    value: function getPathNames() {
      return Object.keys(paths);
    } // Get a path drawing function by name. Returns 'undefined' if not found.

  }, {
    key: "getPath",
    value: function getPath(name) {
      return paths[name];
    } // Return random shape function. It's name is shape.name

  }, {
    key: "oneOf",
    value: function oneOf() {
      // return paths[util.oneValOf(this.getPathNames())]
      return oneValOf(paths);
    } // Return the name/path at index of path array.
    // Wrap the index to be within the array.

  }, {
    key: "nameAtIndex",
    value: function nameAtIndex(index) {
      var names = this.getPathNames();
      return names[mod(index, names.length)];
    }
  }, {
    key: "atIndex",
    value: function atIndex(index) {
      var name = this.nameAtIndex(index);
      return paths[name];
    }
  }, {
    key: "imagePathPromise",
    value: function imagePathPromise(name, imgURL) {
      var _this = this;

      return imagePromise(imgURL).then(function (img) {
        _this.createImagePath(name, img);
      });
    } // Create a shape that is an imageable (img, canvas, ...)

  }, {
    key: "createImagePath",
    value: function createImagePath(name, img) {
      var flip = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      if (!isImageable(img)) {
        throw Error("Shapes createImagePath: img not an imageable " + img);
      }

      if (flip) img = flipImage(img);

      function imagePath(ctx) {
        ctx.drawImage(img, -0.5, -0.5, 1, 1);
      } // paths[name] = imagePath


      this.addPath(name, imagePath);
    }
  }, {
    key: "imageName",
    value: function imageName(name, pixels, fill, stroke) {
      var path = this.getPath(name);
      if (!Number.isInteger(pixels)) throw Error("imageName: pixels is not integer: ".concat(name));
      if (!path) throw Error("imageName: ".concat(name, " not in Shapes"));
      if (path.name === "imagePath") return "".concat(name, "_").concat(pixels, "_image");
      if (!fill) throw Error("imageName: No color for shape ".concat(name)); // OK to give strokeColor when not needed.

      if (!this.needsStrokeColor(name)) stroke = null;
      return "".concat(name, "_").concat(pixels, "_").concat(fill).concat(stroke ? "_".concat(stroke) : "");
    }
  }, {
    key: "shapeToImage",
    value: function shapeToImage(name, pixels, fill, stroke) {
      pixels = Math.ceil(pixels);
      var imgName = this.imageName(name, pixels, fill, stroke);
      if (this.cache && this.cache[imgName]) return this.cache[imgName];
      var ctx = createCtx(pixels, pixels);
      ctx.fillStyle = cssColor$1(fill);
      ctx.strokeStyle = cssColor$1(stroke);
      ctx.scale(pixels, -pixels);
      ctx.translate(0.5, -0.5);
      ctx.beginPath();
      paths[name](ctx);
      ctx.closePath();
      ctx.fill();
      ctx.canvas.name = imgName;
      if (this.cache) this.cache[imgName] = ctx.canvas;
      return ctx.canvas;
    }
  }, {
    key: "imageNameToImage",
    value: function imageNameToImage(imageName) {
      var _imageName$split = imageName.split("_"),
          _imageName$split2 = _slicedToArray(_imageName$split, 4),
          name = _imageName$split2[0],
          pixels = _imageName$split2[1],
          fill = _imageName$split2[2],
          stroke = _imageName$split2[3];

      return this.shapeToImage(name, pixels, fill, stroke);
    }
  }]);

  return Shapes;
}(); // Utilities:

function flipImage(img) {
  var width = img.width,
      height = img.height;
  var ctx = createCtx(width, height);
  ctx.scale(1, -1);
  ctx.drawImage(img, 0, -height);
  return ctx.canvas;
} // Centered polygon, x,y in [-1, 1] (size = 2)


function poly(ctx, points) {
  points.forEach(function (pt, i) {
    if (i === 0) ctx.moveTo(pt[0], pt[1]);else ctx.lineTo(pt[0], pt[1]);
  });
} // centered circle


function _circle(ctx, x, y, radius) {
  var anticlockwise = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  ctx.arc(x, y, radius, 0, 2 * Math.PI, anticlockwise);
} // centered square


function _square(ctx, x, y, size) {
  ctx.fillRect(x - size / 2, y - size / 2, size, size);
} // The paths object containing shape path procedures for common shapes.
// Paths are unit size, -.5 -> +.5
// Use "addPath()" to add your own new shapes.
//
// These are "upsidedown", i.e. not upright. This is so we can traansform
// to euclidean coords.
// Does not impact most paths. But will impact images & person, person2


var paths = {
  // default(ctx) {
  //     this.dart(ctx)
  // },
  arrow: function arrow(ctx) {
    poly(ctx, [[0.5, 0], [0, 0.5], [0, 0.2], [-0.5, 0.2], [-0.5, -0.2], [0, -0.2], [0, -0.5]]);
  },
  bug: function bug(ctx) {
    ctx.strokeStyle = ctx.fillStyle;
    this.bug2(ctx);
  },
  bug2: function bug2(ctx) {
    ctx.lineWidth = 0.05;
    poly(ctx, [[0.4, 0.225], [0.2, 0], [0.4, -0.225]]);
    ctx.stroke();
    ctx.beginPath();

    _circle(ctx, 0.12, 0, 0.13);

    _circle(ctx, -0.05, 0, 0.13);

    _circle(ctx, -0.27, 0, 0.2);
  },
  circle: function circle(ctx) {
    // ctx.arc(0, 0, 1, 0, 2 * Math.PI)
    _circle(ctx, 0, 0, 0.5);
  },
  dart: function dart(ctx) {
    poly(ctx, [[0.5, 0], [-0.5, 0.4], [-0.25, 0], [-0.5, -0.4]]);
  },
  frame: function frame(ctx) {
    var inset = 0.2;
    var r = 0.5 - inset;
    poly(ctx, [[-0.5, -0.5], [0.5, -0.5], [0.5, 0.5], [-0.5, 0.5]]); //cclockwise

    ctx.closePath(); // reverse direction for non-zero winding rule to leave empty center rect.

    poly(ctx, [[-r, -r], [-r, r], [r, r], [r, -r]]); // clockwise
  },
  frame2: function frame2(ctx) {
    var inset = 0.2;

    _square(ctx, 0, 0, 1);

    ctx.fillStyle = ctx.strokeStyle;

    _square(ctx, 0, 0, 1 - 2 * inset); //2 - 2 * inset)

  },
  person: function person(ctx) {
    ctx.strokeStyle = ctx.fillStyle;
    this.person2(ctx);
  },
  person2: function person2(ctx) {
    poly(ctx, [[0.15, 0.2], [0.3, 0], [0.125, -0.1], [0.125, 0.05], [0.1, -0.15], [0.25, -0.5], [0.05, -0.5], [0, -0.25], [-0.05, -0.5], [-0.25, -0.5], [-0.1, -0.15], [-0.125, 0.05], [-0.125, -0.1], [-0.3, 0], [-0.15, 0.2]]);
    ctx.closePath();
    ctx.fill();
    ctx.beginPath();
    ctx.fillStyle = ctx.strokeStyle;

    _circle(ctx, 0, 0.35, 0.15);
  },
  ring: function ring(ctx) {
    var rOuter = 0.5,
        rInner = 0.3;

    _circle(ctx, 0, 0, rOuter);

    ctx.lineTo(rInner, 0);

    _circle(ctx, 0, 0, rInner, true);
  },
  ring2: function ring2(ctx) {
    // fileStyle is outer color, strokeStyle inner color
    var rOuter = 0.5,
        rInner = 0.3;

    _circle(ctx, 0, 0, rOuter);

    ctx.closePath();
    ctx.fill();
    ctx.beginPath();
    ctx.fillStyle = ctx.strokeStyle;

    _circle(ctx, 0, 0, rInner);
  },
  square: function square(ctx) {
    _square(ctx, 0, 0, 1);
  },
  triangle: function triangle(ctx) {
    poly(ctx, [[0.5, 0], [-0.5, -0.4], [-0.5, 0.4]]);
  }
}; // export default Shapes

/*
ToDo:
    - simplify async images: make a "slot" then fill it.
    - manage inversion/upright. Only needed for: person/2, images
    - optimize:
        - cache images .. like spritesheet
        - use shortcuts via the helper functions (avoid transforms)
          See shapes.coffee in as0
    - paths: use object w/ meta-data, & draw(). needsStroke, for example
*/

function cssColor(color) {
  if (color) return color.css || color;
  return color;
}

var TurtlesView = /*#__PURE__*/function () {
  // constructor(ctx, patchSize, world, useSprites = false) {
  function TurtlesView(ctx, world) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, TurtlesView);

    options = Object.assign(TurtlesView.defaultOptions(), options);
    Object.assign(this, {
      ctx: ctx,
      world: world
    }, options);
    this.shapes = new Shapes();
    this.reset(this.patchSize, this.useSprites);
  }

  _createClass(TurtlesView, [{
    key: "reset",
    value: function reset(patchSize) {
      var useSprites = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.useSprites;
      this.useSprites = useSprites;
      this.resetCtx(patchSize); // sets this.patchSize
    }
  }, {
    key: "getImageBitmap",
    value: function getImageBitmap() {
      return createImageBitmap(this.ctx.canvas);
    }
  }, {
    key: "resetCtx",
    value: function resetCtx(patchSize) {
      this.patchSize = patchSize;

      if (this.useSprites) {
        // If using sprites, do not install the transform
        this.world.setCanvasSize(this.ctx.canvas, patchSize); // Fix for sticky euclidean xfm if no size change

        this.ctx.restore(); // util.setIdentity(this.ctx)
      } else {
        // If using shapes, create euclidean transform.
        this.world.setEuclideanTransform(this.ctx, patchSize);
      }
    }
  }, {
    key: "drawTurtles",
    value: function drawTurtles(data, viewFcn) {
      var _this = this;

      if (isOofA(data)) data = toAofO(data);
      var constantView = isObject(viewFcn);
      forLoop(data, function (turtle, i) {
        var viewData = constantView ? viewFcn : viewFcn(turtle, i, data);

        _this.drawTurtle(turtle, viewData);
      });
    }
  }, {
    key: "drawTurtle",
    value: function drawTurtle(turtle, viewData) {
      if (turtle.hidden) return;
      if (viewData.size === 0) return; // skip this turtle if size === 0

      if (this.useSprites) {
        var sprite = viewData.sprite,
            noRotate = viewData.noRotate; // If not the short form, create the image.
        // Not too bad, it uses the shapes.cache after first image.

        if (!sprite) {
          var shape = viewData.shape,
              color = viewData.color,
              strokeColor = viewData.strokeColor,
              size = viewData.size;
          var pixels = size * this.patchSize;
          sprite = this.shapes.shapeToImage(shape, pixels, color, strokeColor);
        }

        if (sprite.sheet) {
          sprite.sheet.draw(this.ctx, sprite, turtle.x, turtle.y, turtle.theta, this.world, this.patchSize, noRotate);
        } else {
          this.drawImage(sprite, turtle.x, turtle.y, noRotate ? 0 : turtle.theta);
        }
      } else {
        var _shape = viewData.shape,
            _color = viewData.color,
            _strokeColor = viewData.strokeColor,
            _size = viewData.size,
            _noRotate = viewData.noRotate;
        this.drawShape(_shape, turtle.x, turtle.y, _noRotate ? 0 : turtle.theta, _size, _color, _strokeColor);
      }
    }
  }, {
    key: "drawShape",
    value: function drawShape(name, x, y) {
      var theta = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      var size = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 1;
      var fill = arguments.length > 5 ? arguments[5] : undefined;
      var stroke = arguments.length > 6 ? arguments[6] : undefined;
      var ctx = this.ctx;
      ctx.save(); // note: neither may be needed! image needs none, no-stroke only fill.

      ctx.fillStyle = cssColor(fill); // fill.css || fill

      ctx.strokeStyle = cssColor(stroke); // stroke.css || stroke

      ctx.translate(x, y);
      ctx.scale(size, size);
      if (theta !== 0) ctx.rotate(theta);
      ctx.beginPath();
      this.shapes.paths[name](ctx);
      ctx.closePath();
      ctx.fill();
      ctx.restore();
    }
  }, {
    key: "drawImage",
    value: function drawImage(img, x, y) {
      var theta = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      var halfPix = img.width / 2;
      var patchSize = this.patchSize; //this.world.canvasPatchSize(ctx.canvas)

      var _this$world$patchXYto = this.world.patchXYtoPixelXY(x, y, patchSize),
          _this$world$patchXYto2 = _slicedToArray(_this$world$patchXYto, 2),
          x0 = _this$world$patchXYto2[0],
          y0 = _this$world$patchXYto2[1];

      var ctx = this.ctx;

      if (theta === 0) {
        ctx.drawImage(img, x0 - halfPix, y0 - halfPix);
      } else {
        ctx.save();
        ctx.translate(x0, y0);
        ctx.rotate(-theta);
        ctx.drawImage(img, -halfPix, -halfPix);
        ctx.restore();
      }
    }
  }, {
    key: "drawLinks",
    value: function drawLinks(data, viewFcn) {
      var _this2 = this;

      if (isOofA(data)) data = toAofO(data);
      var uniformLinks = isObject(viewFcn);
      var ctx = this.ctx;
      setIdentity(this.ctx);

      if (uniformLinks) {
        ctx.strokeStyle = cssColor(viewFcn.color);
        ctx.lineWidth = viewFcn.width || 1;
        ctx.beginPath();
      }

      forLoop(data, function (link, i) {
        if (uniformLinks) {
          _this2.drawLink(link);
        } else {
          var _viewFcn = viewFcn(link, i, data),
              color = _viewFcn.color,
              width = _viewFcn.width;

          _this2.drawLink(link, color, width);
        }
      });

      if (uniformLinks) {
        ctx.closePath();
        ctx.stroke();
      }

      this.ctx.restore(); // set identity does a save()
    }
  }, {
    key: "drawLink",
    value: function drawLink(link, color) {
      var width = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
      this.drawLine(link.x0, link.y0, link.x1, link.y1, color, width);
    }
  }, {
    key: "drawLine",
    value: function drawLine(x0, y0, x1, y1, stroke) {
      var width = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 1;
      // ctx.save() // set identity does a save()
      var ctx = this.ctx;

      var _this$world$patchXYto3 = this.world.patchXYtoPixelXY(x0, y0, this.patchSize);

      var _this$world$patchXYto4 = _slicedToArray(_this$world$patchXYto3, 2);

      x0 = _this$world$patchXYto4[0];
      y0 = _this$world$patchXYto4[1];

      var _this$world$patchXYto5 = this.world.patchXYtoPixelXY(x1, y1, this.patchSize);

      var _this$world$patchXYto6 = _slicedToArray(_this$world$patchXYto5, 2);

      x1 = _this$world$patchXYto6[0];
      y1 = _this$world$patchXYto6[1];

      if (stroke) {
        ctx.strokeStyle = cssColor(stroke);
        ctx.lineWidth = width;
        ctx.beginPath();
      }

      ctx.moveTo(x0, y0);
      ctx.lineTo(x1, y1); // util.setIdentity(ctx)

      if (stroke) {
        ctx.closePath();
        ctx.stroke();
      } // ctx.restore()

    }
  }], [{
    key: "defaultOptions",
    value: function defaultOptions() {
      return {
        // canvasStack: false,
        useSprites: false,
        patchSize: 10
      };
    }
  }]);

  return TurtlesView;
}();

var TwoView = /*#__PURE__*/function () {
  // ======================
  // Note: world can be a model, who'd model.world will be used
  function TwoView(world) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, TwoView);

    // options: override defaults, assign to this
    // Object.assign(this, TwoView.defaultOptions(), options)
    options = Object.assign(TwoView.defaultOptions(), options);

    if (options.width) {
      options.patchSize = options.width / world.width;
      delete options.width;
    }

    this.div = options.div; // let div = this.div

    var div = options.div;
    var can = div;
    div = isString(div) ? document.getElementById(div) : div;

    if (!isCanvas(can)) {
      can = createCanvas(0, 0, false); // not offscreen

      div.appendChild(can); // div = can
    } // this.div = div


    this.ctx = can.getContext("2d");
    this.world = new World(world.world || world); // world can be model
    // Object.assign(this, { ctx, world }, options)
    // Object.assign(this, { ctx, world })

    this.patchesView = new PatchesView(this.world.width, this.world.height);
    this.turtlesView = new TurtlesView(this.ctx, this.world, options);
    this.ticks = 0;
    this.clear();
  }

  _createClass(TwoView, [{
    key: "tick",
    value: function tick() {
      this.ticks++;
    }
  }, {
    key: "canvas",
    get: function get() {
      return this.ctx.canvas;
    } // setPatchSize(patchSize) {
    //     this.reset(patchSize)
    // }
    // setWidth(width) {
    //     this.reset(width / this.world.width)
    // }
    // get patchSize() {
    //     this.turtlesView.patchSize
    // }

  }, {
    key: "reset",
    value: function reset(patchSize) {
      var useSprites = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.useSprites;
      // if (this.width) this.width = patchSizeOrWidth
      // this.patchSize = this.width
      //     ? this.width / this.world.width
      //     : patchSizeOrWidth
      // this.patchSize = patchSize
      // this.useSprites = useSprites
      this.turtlesView.reset(patchSize, useSprites);
    }
  }, {
    key: "width",
    get: function get() {
      // return this.world.width * this.turtlesView.patchSize // this.patchSize
      return this.world.width * this.patchSize;
    },
    set: function set(val) {
      this.reset(val / this.world.width);
    }
  }, {
    key: "patchSize",
    get: function get() {
      return this.turtlesView.patchSize;
    },
    set: function set(val) {
      this.reset(val);
    }
  }, {
    key: "useSprites",
    get: function get() {
      return this.turtlesView.useSprites;
    },
    set: function set(val) {
      this.reset(this.patchSize, val);
    } // Clear the view.canvas.
    // If no color, or 'transparent', make transparent via clearCtx.
    // If cssColor.css (typedColor) use it, else cssColor

  }, {
    key: "clear",
    value: function clear(cssColor) {
      clearCtx(this.ctx, cssColor); // REMIND: Clear the pixels?
      // this.patchesView.clear(cssColor)
    }
  }, {
    key: "createPatchPixels",
    value: function createPatchPixels(pixelFcn) {
      this.patchesView.createPixels(pixelFcn);
    } // setPatchPixel(x, y, pixel) {
    //     this.patchesView.setPixel(x, y, pixel)
    // }

  }, {
    key: "setPatchPixel",
    value: function setPatchPixel(index, pixel) {
      this.patchesView.setPixel(index, pixel);
    }
  }, {
    key: "setPatchesPixels",
    value: function setPatchesPixels(data, pixelFcn) {
      this.patchesView.setPixels(data, pixelFcn);
    }
  }, {
    key: "setPatchesSmoothing",
    value: function setPatchesSmoothing(smoothing) {
      this.patchesView.setPatchesSmoothing(smoothing);
    }
  }, {
    key: "drawPatchesImage",
    value: function drawPatchesImage(img) {
      // if (img) util.fillCtxWithImage(this.ctx, img) ??
      fillCtxWithImage(this.ctx, img);
    } // If no data, redraw with existing patchesView cache

  }, {
    key: "drawPatches",
    value: function drawPatches(data, pixelFcn) {
      if (data != null) {
        this.patchesView.setPixels(data, pixelFcn);
      }

      this.patchesView.draw(this.ctx);
    }
  }, {
    key: "drawTurtles",
    value: function drawTurtles(data, viewFcn) {
      this.turtlesView.drawTurtles(data, viewFcn);
    }
  }, {
    key: "drawLinks",
    value: function drawLinks(data, viewFcn) {
      this.turtlesView.drawLinks(data, viewFcn);
    }
  }, {
    key: "setTextProperties",
    value: function setTextProperties$1(font) {
      var textAlign = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "center";
      var textBaseline = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "middle";
      if (typeof font === "number") font = "".concat(this.patchSize * font, "px sans-serif");
      setTextProperties(this.ctx, font, textAlign, textBaseline);
    }
  }, {
    key: "drawText",
    value: function drawText$1(string, x, y) {
      var color = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "black";

      var _this$world$patchXYto = this.world.patchXYtoPixelXY(x, y, this.patchSize);

      var _this$world$patchXYto2 = _slicedToArray(_this$world$patchXYto, 2);

      x = _this$world$patchXYto2[0];
      y = _this$world$patchXYto2[1];
      string = "" + string; // convert numeric values to strings

      drawText(this.ctx, string, x, y, color);
    }
  }], [{
    key: "defaultOptions",
    value: function defaultOptions() {
      return {
        div: document.body,
        useSprites: false,
        patchSize: 10 // width: null,

      };
    }
  }]);

  return TwoView;
}();

var ColorMap = {
  // ### Color Array Utilities
  // Several utilities for creating color arrays
  // ### Gradients
  // Ask the browser to use the canvas gradient feature
  // to create nColors given the gradient color stops and locs.
  // See Mozilla [Gradient Doc](
  // https://developer.mozilla.org/en-US/docs/Web/CSS/linear-gradient),
  //
  // This is a powerful browser feature, can be
  // used to create all the MatLab colormaps.
  //
  // Stops are css strings.
  // Locs are floats from 0-1, default is equally spaced.
  gradientImageData: function gradientImageData(nColors, stops, locs) {
    // Convert the color stops to css strings
    // stops = stops.map(c => cssColor(c))
    var ctx = createCtx(nColors, 1); // Install default locs if none provide

    if (!locs) locs = floatRamp(0, 1, stops.length); // Create a new gradient and fill it with the color stops

    var grad = ctx.createLinearGradient(0, 0, nColors, 0);
    repeat(stops.length, function (i) {
      return grad.addColorStop(locs[i], stops[i]);
    }); // Draw the gradient, returning the image data TypedArray

    ctx.fillStyle = grad;
    ctx.fillRect(0, 0, nColors, 1);
    return ctxImageData(ctx).data;
  },
  // ### Array Conversion Utilities
  // Convert a Uint8Array into Array of 4 element typedColors.
  // Useful for converting ImageData objects like gradients to colormaps.
  // WebGL ready: the array.typedArray is suitable for Uniforms.
  typedArraytoColors: function typedArraytoColors(typedArray) {
    var array = [];
    step(typedArray.length, 4, // Note: can't share subarray as color's typed array:
    // it's buffer is for entire array, not just subarray.
    function (i) {
      return array.push(Color.typedColor.apply(Color, _toConsumableArray(typedArray.subarray(i, i + 4))));
    });
    array.typedArray = typedArray;
    return array;
  },
  // Convert an Array of Arrays to an Array of typedColors.
  // Webgl ready as above.
  arraysToColors: function arraysToColors(array) {
    var typedArray = new Uint8ClampedArray(array.length * 4);
    repeat(array.length, function (i) {
      var a = array[i];
      if (a.length === 3) a.push(255);
      typedArray.set(a, i * 4);
    });
    return this.typedArraytoColors(typedArray);
  },
  // Permute the values of 3 arrays. Ex:
  //
  // [1,2],[3],[4,5] -> [ [1,3,4],[1,3,5],[2,3,4],[2,3,5] ]
  permuteArrays: function permuteArrays(A1) {
    var A2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : A1;
    var A3 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : A1;
    var array = [];

    var _iterator = _createForOfIteratorHelper(A3),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var a3 = _step.value;

        // sorta odd const works with ths, but...
        var _iterator2 = _createForOfIteratorHelper(A2),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var a2 = _step2.value;

            var _iterator3 = _createForOfIteratorHelper(A1),
                _step3;

            try {
              for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                var a1 = _step3.value;
                array.push([a1, a2, a3]);
              }
            } catch (err) {
              _iterator3.e(err);
            } finally {
              _iterator3.f();
            }
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    return array;
  },
  // Use permuteArrays to create uniformly spaced color ramp permutation.
  // Ex: if numRs is 3, permuteArrays's A1 would be [0, 127, 255]
  permuteRGBColors: function permuteRGBColors(numRs) {
    var numGs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : numRs;
    var numBs = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : numRs;

    var toRamp = function toRamp(num) {
      return integerRamp(0, 255, num);
    };

    var ramps = [numRs, numGs, numBs].map(toRamp);
    return this.permuteArrays.apply(this, _toConsumableArray(ramps));
  },
  // ### ColorMaps
  // ColorMaps are Arrays of TypedColors with these additional methods. Webgl
  // ready if made w/ `typedArraytoColors` or `arraysToColors` above.
  // Used to be memory effecent (shared colors), webgl compatible,  and for
  // MatLab-like color-as-data.
  ColorMapProto: {
    // Inherit from Array
    __proto__: Array.prototype,
    // Create a [sparse array](https://goo.gl/lQlq5k) of index[pixel] = pixel.
    // Used by indexOf below for exact match of a color within the colormap.
    createIndex: function createIndex() {
      var _this = this;

      this.index = [];
      repeat(this.length, function (i) {
        var px = _this[i].getPixel();

        _this.index[px] = i;
        if (_this.cssNames) _this.index[_this.cssNames[i]] = i;
      });
    },
    // Return a random color within the colormap
    randomColor: function randomColor() {
      return this[randomInt(this.length)];
    },
    // Set alpha of all the colors ih the map
    // Note this will be shared by all users of this map!
    // Use clone() to have your own copy of a shared map.
    setAlpha: function setAlpha(alpha) {
      forLoop(this, function (color) {
        return color.setAlpha(alpha);
      });
    },
    // Clone this colorMap
    clone: function clone() {
      return ColorMap.cloneColorMap(this);
    },
    // Return the color at index of this array.
    // Wrap the index to be within the array.
    atIndex: function atIndex(index) {
      return this[index % this.length];
    },
    // Return the index of a typedColor within the colormap,
    // undefined if no exact match.
    // Use the `closest` methods below for nearest, not exact, match.
    indexOf: function indexOf(color) {
      if (this.index) return this.index[color.getPixel()];

      for (var i = 0; i < this.length; i++) {
        if (color.equals(this[i])) return i;
      }

      return undefined;
    },
    // Return color scaled by number within [min, max].
    // A linear interpolation (util.lerp) in [0, length-1].
    // Used to match data directly to a color as in MatLab.
    //
    // Ex: scaleColor(25, 0, 50) returns the color in the middle of the colormap
    scaleColor: function scaleColor(number, min, max) {
      // number = util.clamp(number, min, max)
      var scale = lerpScale(number, min, max);
      var index = Math.round(lerp(0, this.length - 1, scale));
      return this[index];
    },
    // Return the Uint8 array used to create the typedColors,
    // undefined if not webgl ready.
    // webglArray() {
    //     return this.typedArray
    // },
    // Debugging: Return a string with length and array of colors
    toString: function toString() {
      return "".concat(this.length, " ").concat(arraysToString(this));
    },
    // Iterate through the colormap colors, returning the index of the
    // min typedColor.rgbDistance value from r, g, b
    rgbClosestIndex: function rgbClosestIndex(r, g, b) {
      var minDist = Infinity;
      var ixMin = 0;

      for (var i = 0; i < this.length; i++) {
        var d = this[i].rgbDistance(r, g, b);

        if (d < minDist) {
          minDist = d;
          ixMin = i;
          if (d === 0) return ixMin;
        }
      }

      return ixMin;
    },
    // Return the color with the rgbClosestIndex value
    rgbClosestColor: function rgbClosestColor(r, g, b) {
      return this[this.rgbClosestIndex(r, g, b)];
    },
    // Calculate the closest cube index for the given r, g, b values.
    // Faster than rgbClosestIndex, does direct calculation, not iteration.
    cubeClosestIndex: function cubeClosestIndex(r, g, b) {
      var cube = this.cube;
      var rgbSteps = cube.map(function (c) {
        return 255 / (c - 1);
      });
      var rgbLocs = [r, g, b].map(function (c, i) {
        return Math.round(c / rgbSteps[i]);
      });

      var _rgbLocs = _slicedToArray(rgbLocs, 3),
          rLoc = _rgbLocs[0],
          gLoc = _rgbLocs[1],
          bLoc = _rgbLocs[2];

      return rLoc + gLoc * cube[0] + bLoc * cube[0] * cube[1];
    },
    cubeClosestColor: function cubeClosestColor(r, g, b) {
      return this[this.cubeClosestIndex(r, g, b)];
    },
    // Choose the appropriate method for finding closest index.
    // Lets the user specify any color, and let the colormap
    // use the best match.
    closestIndex: function closestIndex(r, g, b) {
      return this.cube ? this.cubeClosestIndex(r, g, b) : this.rgbClosestIndex(r, g, b);
    },
    // Choose the appropriate method for finding closest color
    closestColor: function closestColor(r, g, b) {
      return this[this.closestIndex(r, g, b)];
    }
  },
  // ### Utilities for constructing ColorMaps
  // Convert an array of rgb(a) Arrays or TypedColors to a webgl-ready colormap.
  basicColorMap: function basicColorMap(colors) {
    colors = this.arraysToColors(colors);
    Object.setPrototypeOf(colors, this.ColorMapProto);
    return colors;
  },
  // Create a gray map (gray: r=g=b)
  // These are typically 256 entries but can be smaller
  // by passing a size parameter and the min/max range.
  grayColorMap: function grayColorMap() {
    var min = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var max = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 255;
    var size = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : max - min + 1;
    var ramp = integerRamp(min, max, size);
    return this.basicColorMap(ramp.map(function (i) {
      return [i, i, i];
    }));
  },
  // Create a colormap by permuted rgb values.
  //
  // numRs, numGs, numBs are numbers, the number of steps beteen 0-255.
  // Ex: numRs = 3, corresponds to 0, 128, 255.
  // NOTE: the defaults: rgbColorCube(6) creates a `6 * 6 * 6` cube.
  rgbColorCube: function rgbColorCube(numRs) {
    var numGs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : numRs;
    var numBs = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : numRs;
    var array = this.permuteRGBColors(numRs, numGs, numBs);
    var map = this.basicColorMap(array); // Save the parameters for fast color calculations.

    map.cube = [numRs, numGs, numBs];
    return map;
  },
  // Create a colormap by permuting the values of the given arrays.
  // Similar to above but with arrays that may have arbitrary values.
  rgbColorMap: function rgbColorMap(R, G, B) {
    var array = this.permuteArrays(R, G, B);
    return this.basicColorMap(array);
  },
  // Create an hsl map, inputs are arrays to be permutted like rgbColorMap.
  // Convert the HSL values to Color.colors, default to bright hue ramp (L=50).
  hslColorMap: function hslColorMap(H) {
    var S = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [100];
    var L = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [50];
    var hslArray = this.permuteArrays(H, S, L);
    var array = hslArray.map(function (a) {
      return Color.toTypedColor(Color.hslCssColor.apply(Color, _toConsumableArray(a)));
    });
    return this.basicColorMap(array);
  },
  // Use gradient to build an rgba array, then convert to colormap.
  // Stops are css strings or typedColors.
  // locs defaults to evenly spaced, probably what you want.
  //
  // This easily creates all the MatLab colormaps like "jet" below.
  gradientColorMap: function gradientColorMap(nColors, stops, locs) {
    // Convert the color stops to css strings
    stops = stops.map(function (c) {
      return c.css || c;
    });
    var uint8arrays = this.gradientImageData(nColors, stops, locs);
    var typedColors = this.typedArraytoColors(uint8arrays);
    Object.setPrototypeOf(typedColors, this.ColorMapProto);
    return typedColors;
  },
  // The most popular MatLab gradient, "jet":
  jetColors: ["rgb(0, 0, 127)", "rgb(0, 0, 255)", "rgb(0, 127, 255)", "rgb(0, 255, 255)", "rgb(127, 255, 127)", "rgb(255, 255, 0)", "rgb(255, 127, 0)", "rgb(255, 0, 0)", "rgb(127, 0, 0)"],
  // Two other popular MatLab 'ramp' gradients are:
  // * One color: from black/white to color, optionally back to white/black.
  // stops = ['black', 'red'] or ['white', 'orange', 'black']
  // The NetLogo map is a concatenation of 14 of these.
  // * Two colors: stops = ['red', 'orange'] (blends the tow, center is white)
  // The 16 unique [CSS Color Names](https://goo.gl/sxo36X), case insensitive.
  // In CSS 2.1, the color 'orange' was added to the 16 colors as a 17th color
  // Aqua == Cyan and Fuchsia == Magenta, 19 total color names.
  // These sorted by hue/saturation/light, hue in 0-300 degrees.
  // See [Mozilla Color Docs](https://goo.gl/tolSnS) for *lots* more!
  basicColorNames: "white silver gray black red maroon yellow orange olive lime green cyan teal blue navy magenta purple".split(" "),
  brightColorNames: "white silver red maroon yellow orange olive lime green cyan teal blue navy magenta purple".split(" "),
  // Create a named colors colormap
  cssColorMap: function cssColorMap(cssArray) {
    var createNameIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var array = cssArray.map(function (str) {
      return Color.cssToUint8Array(str);
    });
    var map = this.basicColorMap(array);
    map.cssNames = cssArray; // REMIND: kinda tacky? Maybe map.name.yellow? Maybe generalize for other
    // map types: map.closest(name)

    if (createNameIndex) {
      cssArray.forEach(function (name, ix) {
        map[name] = map[ix];
      });
      if (map.cyan) map.aqua = map.cyan;
      if (map.magenta) map.fuchsia = map.magenta;
    }

    return map;
  },
  // Clone a colorMap. Useful if you want to mutate an existing shared map
  cloneColorMap: function cloneColorMap(colorMap) {
    var keys = Object.keys(colorMap);
    var clone = this.basicColorMap(colorMap);
    forLoop(keys, function (val, i) {
      if (clone[i] === undefined) clone[val] = colorMap[val];
    });
    return clone;
  },
  // ### Shared Global ColorMaps
  // NOTE: Do NOT modify one of these, they are shared and would
  // surprise anyone useing them. Use cloneColorMap() to have your own
  // private one, or call any of the map factories above .. see below.
  // The shared global colormaps are lazy evaluated to minimize memory use.
  // NOTE: these are shared, so any change in them are seen by all users!
  LazyMap: function LazyMap(name, map) {
    Object.defineProperty(this, name, {
      value: map,
      enumerable: true
    });
    return map;
  },

  get Gray() {
    return this.LazyMap("Gray", this.grayColorMap());
  },

  get LightGray() {
    return this.LazyMap("LightGray", this.grayColorMap(200));
  },

  get DarkGray() {
    return this.LazyMap("DarkGray", this.grayColorMap(0, 100));
  },

  get Jet() {
    return this.LazyMap("Jet", this.gradientColorMap(256, this.jetColors));
  },

  get Rgb256() {
    return this.LazyMap("Rgb256", this.rgbColorCube(8, 8, 4));
  },

  get Rgb() {
    return this.LazyMap("Rgb", this.rgbColorCube(16));
  },

  get Basic16() {
    // 17 unique + 2 "aliases" = 19 names. "16" historic
    return this.LazyMap("Basic16", this.cssColorMap(this.basicColorNames, true));
  },

  get Bright16() {
    // Basic16 w/o grays: white, black
    return this.LazyMap("Bright16", this.cssColorMap(this.brightColorNames, true));
  }

};

/**
 * Basic 2D view.
 *
 * **TODO: Document this class**
 */

var TwoDraw = /*#__PURE__*/function (_TwoView) {
  _inherits(TwoDraw, _TwoView);

  var _super = _createSuper(TwoDraw);

  // ======================
  function TwoDraw(model) {
    var _this;

    var viewOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var drawOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, TwoDraw);

    // drawOptions = Object.assign({}, TwoDraw.defaultOptions(), drawOptions)
    if (viewOptions.drawOptions) {
      drawOptions = viewOptions.drawOptions;
      delete viewOptions.drawOptions;
    }

    drawOptions = Object.assign(TwoDraw.defaultOptions(), drawOptions);
    if (typeof drawOptions.turtlesMap === "string") drawOptions.turtlesMap = ColorMap[drawOptions.turtlesMap];
    if (typeof drawOptions.patchesMap === "string") drawOptions.patchesMap = ColorMap[drawOptions.patchesMap];
    _this = _super.call(this, model.world, viewOptions);
    _this.model = model;
    _this.view = _assertThisInitialized(_this);

    _this.checkParams(drawOptions);

    _this.drawOptions = drawOptions;
    return _this;
  } // name need not end ".png", will be added if needed.
  // if name undefined use model name, lowerCase'd w/ "Model" removed
  // downloadCanvas(name = undefined) {
  //     if (!name)
  //         name = this.model.constructor.name
  //             .toLowerCase()
  //             .replace(/model$/, '')
  //     util.downloadCanvas(this.canvas, name)
  // }
  // The parameters are easily mistaken: check they are all in the defaults.


  _createClass(TwoDraw, [{
    key: "checkParams",
    value: function checkParams(params) {
      var keys = Object.keys(params);
      var defaults = TwoDraw.defaultOptions();
      keys.forEach(function (k) {
        if (defaults[k] === undefined) {
          console.log("Legal TwoDraw parameters", Object.keys(TwoDraw.defaultOptions()));
          throw Error("Unknown TwoDraw parameter: " + k);
        }
      });
    }
  }, {
    key: "draw",
    value: function draw() {
      // params = Object.assign({}, TwoDraw.defaultOptions(), params)
      var _this$drawOptions = this.drawOptions,
          patchesColor = _this$drawOptions.patchesColor,
          initPatches = _this$drawOptions.initPatches,
          turtlesColor = _this$drawOptions.turtlesColor,
          turtlesStrokeColor = _this$drawOptions.turtlesStrokeColor,
          turtlesShape = _this$drawOptions.turtlesShape,
          turtlesSize = _this$drawOptions.turtlesSize,
          linksColor = _this$drawOptions.linksColor,
          linksWidth = _this$drawOptions.linksWidth,
          textProperty = _this$drawOptions.textProperty,
          textSize = _this$drawOptions.textSize,
          textColor = _this$drawOptions.textColor,
          patchesMap = _this$drawOptions.patchesMap,
          turtlesMap = _this$drawOptions.turtlesMap;
      var model = this.model,
          view = this.view;

      if (view.ticks === 0) {
        if (textProperty) view.setTextProperties(textSize);

        if (initPatches) {
          // colors is an array of typedColors or pixels:
          var colors = initPatches(model, view);
          view.createPatchPixels(function (i) {
            return colors[i];
          });
        } else if (patchesColor === "random") {
          // NOTE: random colors only done once for patches.
          view.createPatchPixels(function (i) {
            return patchesMap.randomColor();
          });
        }
      }

      if (patchesColor === "random" || initPatches) {
        view.drawPatches(); // redraw cached patches colors below
      } else if (typeof patchesColor === "function") {
        view.drawPatches(model.patches, function (p) {
          return patchesColor(p);
        });
      } else if (isImageable(patchesColor)) {
        view.drawPatchesImage(patchesColor);
      } else {
        view.clear(patchesColor);
      }

      var checkColor = function checkColor(agent, color) {
        return color === "random" ? turtlesMap.atIndex(agent.id).css : color;
      }; // const checkColor = (agent, color) => {
      //     if (!turtlesMap) debugger
      //     color === 'random' ? turtlesMap.atIndex(agent.id).css : color
      // }


      view.drawLinks(model.links, function (l) {
        return {
          color: linksColor === "random" ? turtlesMap.atIndex(l.id) : typeof linksColor === "function" ? checkColor(l, linksColor(l)) : linksColor,
          width: linksWidth
        };
      });
      view.drawTurtles(model.turtles, function (t) {
        return {
          shape: typeof turtlesShape === "function" ? turtlesShape(t) : turtlesShape,
          color: turtlesColor === "random" ? turtlesMap.atIndex(t.id).css : typeof turtlesColor === "function" ? checkColor(t, turtlesColor(t)) : turtlesColor,
          strokeColor: turtlesStrokeColor === "random" ? turtlesMap.atIndex(t.id + 4).css : typeof turtlesColor === "function" ? checkColor(t, turtlesColor(t)) : turtlesColor,
          size: typeof turtlesSize === "function" ? turtlesSize(t) : turtlesSize
        };
      });

      if (textProperty) {
        model.turtles.ask(function (t) {
          if (t[textProperty] != null) view.drawText(t[textProperty], t.x, t.y, textColor);
        });
      }

      view.tick();
    }
  }], [{
    key: "defaultOptions",
    value: function defaultOptions() {
      return {
        patchesColor: "random",
        initPatches: null,
        turtlesColor: "random",
        turtlesStrokeColor: "random",
        turtlesShape: "dart",
        turtlesSize: 1,
        linksColor: "random",
        linksWidth: 1,
        textProperty: null,
        textSize: 0.5,
        textColor: "black",
        // patchesMap: ColorMap.DarkGray,
        // turtlesMap: ColorMap.Basic16,
        patchesMap: "DarkGray",
        turtlesMap: "Basic16"
      };
    }
  }]);

  return TwoDraw;
}(TwoView);

var Animator = /*#__PURE__*/function () {
  function Animator(fcn) {
    var steps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : -1;
    var fps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 30;

    _classCallCheck(this, Animator);

    Object.assign(this, {
      fcn: fcn,
      steps: steps,
      fps: fps,
      timeoutID: null,
      ticks: 0
    });
    this.start();
  }

  _createClass(Animator, [{
    key: "start",
    value: function start() {
      var _this = this;

      if (this.timeoutID) return; // avoid multiple starts

      this.timeoutID = setInterval(function () {
        return _this.step();
      }, 1000 / this.fps);
      return this; // chaining off ctor
    }
  }, {
    key: "stop",
    value: function stop() {
      if (this.timeoutID) clearInterval(this.timeoutID);
      this.timeoutID = null;
      return this; // chaining off ctor
    }
  }, {
    key: "step",
    value: function step() {
      if (this.steps === 0) return this.stop();
      this.ticks++;
      this.steps--;
      this.fcn();
      if (this.stats) this.stats.update();
      return this; // chaining off ctor
    }
  }, {
    key: "isRunning",
    value: function isRunning() {
      return this.timeoutID != null;
    } // startStats() {
    //   if (this.stats) return console.log("startStats: already running");
    //   import("https://cdn.skypack.dev/stats.js").then((m) => {
    //     this.stats = new m.default();
    //     document.body.appendChild(this.stats.dom);
    //   });
    //   return this; // chaining off ctor
    // }
    // Stop and restart with the new steps & fps

  }, {
    key: "reset",
    value: function reset() {
      var steps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : -1;
      var fps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.fps;
      this.stop();
      this.steps = steps;
      this.ticks = 0;
      this.fps = fps;
      this.start();
    } // stop if running, start otherwise
    // if starting and steps === 0, reset with steps = -1, forever.

  }, {
    key: "toggle",
    value: function toggle() {
      if (this.timeoutID) this.stop();else if (this.steps === 0) this.reset();else this.start();
    } // call the fcn once. stops if currently running

  }, {
    key: "once",
    value: function once() {
      this.stop();
      this.step();
    }
  }]);

  return Animator;
}();

var css_248z = ":root {\n  --background: #fff;\n  --font-color: #494949;\n}\n\n@media (prefers-color-scheme: dark) {\n  :root {\n    --background: #3c3c3c;\n    --font-color: #fafafa;\n  }\n}\n.foo-bar {\n  font-family: \"Avenir Next\", Helvetica, Arial, sans-serif;\n  color: #005f20;\n}";
styleInject(css_248z);

var Agentscript = function (_a) {
    var view = _a.view, animation = _a.animation, Model = _a.Model;
    useEffect(function () {
        var agentSetup = function () { return __awaiter(void 0, void 0, void 0, function () {
            var model, width, drawOptions, twoDraw, step, fps;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        model = new Model();
                        return [4 /*yield*/, model.startup()];
                    case 1:
                        _a.sent();
                        model.setup();
                        width = view.width, drawOptions = view.drawOptions;
                        twoDraw = new TwoDraw(model, {
                            div: 'modelDiv',
                            useSprites: true,
                            width: width,
                            drawOptions: drawOptions,
                        });
                        step = animation.step, fps = animation.fps;
                        new Animator(function () {
                            model.step();
                            twoDraw.draw();
                        }, step, fps);
                        return [2 /*return*/];
                }
            });
        }); };
        agentSetup();
    }, []);
    return (React.createElement("div", { id: "modelDiv" }));
};

export { Agentscript, TestComponent };
//# sourceMappingURL=index.esm.js.map
